Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 6639)
@@ -792,14 +1318,33 @@
 
                !! sum tracers for inventory checks
-               ftot_n  = fthk * ( zphn + zphd + zzmi + zzme + zdet + zdin )
-               ftot_si = fthk * ( zpds + zsil )
-               ftot_fe = fthk * ( xrfn * ( zphn + zphd + zzmi + zzme + zdet ) + zfer )
+               IF( lk_iomput ) THEN
+                  IF ( med_diag%INVTN%dgsave )   THEN
+                     ftot_n(ji,jj)  = ftot_n(ji,jj) + &
+                             (fthk * ( zphn + zphd + zzmi + zzme + zdet + zdin ) )
+                  ENDIF
+                  IF ( med_diag%INVTSI%dgsave )  THEN
+                     ftot_si(ji,jj) = ftot_si(ji,jj) + & 
+                             (fthk * ( zpds + zsil ) )
+                  ENDIF
+                  IF ( med_diag%INVTFE%dgsave )  THEN
+                     ftot_fe(ji,jj) = ftot_fe(ji,jj) + & 
+                             (fthk * ( xrfn * ( zphn + zphd + zzmi + zzme + zdet ) + zfer ) )
+                  ENDIF
 # if defined key_roam
-               ftot_c  = fthk * ( (xthetapn * zphn) + (xthetapd * zphd) + &
-                         (xthetazmi * zzmi) + (xthetazme * zzme) + zdtc + &
-                         zdic )
-               ftot_a  = fthk * ( zalk )
-               ftot_o2 = fthk * ( zoxy )
-# endif
+                  IF ( med_diag%INVTC%dgsave )  THEN
+                     ftot_c(ji,jj)  = ftot_c(ji,jj) + & 
+                             (fthk * ( (xthetapn * zphn) + (xthetapd * zphd) + &
+                             (xthetazmi * zzmi) + (xthetazme * zzme) + zdtc +   &
+                             zdic ) )
+                  ENDIF
+                  IF ( med_diag%INVTALK%dgsave ) THEN
+                     ftot_a(ji,jj)  = ftot_a(ji,jj) + (fthk * ( zalk ) )
+                  ENDIF
+                  IF ( med_diag%INVTO2%dgsave )  THEN
+                     ftot_o2(ji,jj) = ftot_o2(ji,jj) + (fthk * ( zoxy ) )
+                  ENDIF
+# endif
+               ENDIF
+
                CALL flush(numout)
 
@@ -814,7 +1359,4 @@
                   !!----------------------------------------------------------------------
                   !!
-                  !! a bit of set up ...
-                  ! f_uwind = zwnd_i(ji,jj)
-                  ! f_vwind = zwnd_j(ji,jj)
                   !! AXY (17/07/14): zwind_i and zwind_j do not exist in this
                   !!                 version of NEMO because it does not include
@@ -827,22 +1369,32 @@
                   !!                 revisited when MEDUSA properly interacts
                   !!                 with UKESM1 physics
-                  ! f_uwind = zwind_i(ji,jj)
-                  ! f_vwind = zwind_j(ji,jj)
-                  ! f_wind  = ((f_uwind**2.0) + (f_vwind**2.0))**0.5
+                  !!
                   f_wind  = wndm(ji,jj)
-                  !! AXY (17/07/14): the current oxygen code takes in separate
-                  !!                 U and V components of the wind; to avoid
-                  !!                 the need to change this, calculate these
-                  !!                 components based on wndm; again, this is
-                  !!                 not ideal, but should suffice as a
-                  !!                 temporary measure; in the long-term all
-                  !!                 of MEDUSA's air-sea gas exchange terms
-                  !!                 will be revisited to ensure that they are
-                  !!                 valid and self-consistent; and the CO2
-                  !!                 code will be wholly replaced with a more
-                  !!                 up-to-date parameterisation
-                  f_uwind = ((f_wind**2.0) / 2.0)**0.5
-                  f_vwind = f_uwind
+                  !!
+                  !! AXY (23/06/15): as part of an effort to update the carbonate chemistry
+                  !!                 in MEDUSA, the gas transfer velocity used in the carbon
+                  !!                 and oxygen cycles has been harmonised and is calculated
+                  !!                 by the same function here; this harmonisation includes
+                  !!                 changes to the PML carbonate chemistry scheme so that
+                  !!                 it too makes use of the same gas transfer velocity; the
+                  !!                 preferred parameterisation of this is Wanninkhof (2014),
+                  !!                 option 7
+                  !!
+#   if defined key_debug_medusa
+                     IF (lwp) write (numout,*) 'trc_bio_medusa: entering gas_transfer'
+                     CALL flush(numout)
+#   endif
+                  CALL gas_transfer( f_wind, 1, 7, &  ! inputs
+                                     f_kw660 )        ! outputs
+#   if defined key_debug_medusa
+                     IF (lwp) write (numout,*) 'trc_bio_medusa: exiting gas_transfer'
+                     CALL flush(numout)
+#   endif
+                  !!
+                  !! air pressure (atm); ultimately this will use air pressure at the base
+                  !! of the UKESM1 atmosphere 
+                  !!                                     
                   f_pp0   = 1.0
+                  !!
                   !! IF(lwp) WRITE(numout,*) ' MEDUSA ztmp    =', ztmp
                   !! IF(lwp) WRITE(numout,*) ' MEDUSA zwind_i =', zwind_i(ji,jj)
@@ -852,10 +1404,26 @@
                   !!
 #  if defined key_axy_carbchem
+#   if defined key_mocsy
+                  !!
+                  !! AXY (22/06/15): use Orr & Epitalon (2015) MOCSY-2 carbonate
+                  !!                 chemistry package; note that depth is set to
+                  !!                 zero in this call
+                  CALL mocsy_interface( ztmp, zsal, zalk, zdic, zsil, zpho,        &  ! inputs
+                  f_pp0, 0.0, flatx, f_kw660, f_pco2a, 1,                          &  ! inputs
+                  f_ph, f_pco2w, f_fco2w, f_h2co3, f_hco3, f_co3, f_omarg(ji,jj),  &  ! outputs
+                  f_omcal(ji,jj), f_BetaD, f_rhosw, f_opres, f_insitut,            &  ! outputs
+                  f_pco2atm, f_fco2atm, f_schmidtco2, f_kwco2, f_K0,               &  ! outputs
+                  f_co2starair, f_co2flux, f_dpco2 )                                  ! outputs
+                  !!
+                  f_TDIC = (zdic / f_rhosw) * 1000. ! mmol / m3 -> umol / kg
+                  f_TALK = (zalk / f_rhosw) * 1000. !  meq / m3 ->  ueq / kg
+                  f_dcf  = f_rhosw
+#   else                  
                   iters = 0
                   !!
                   !! carbon dioxide (CO2); Jerry Blackford code (ostensibly OCMIP-2, but not)
-                  CALL trc_co2_medusa( ztmp, zsal, zdic, zalk, 0.0, f_wind, f_pco2a, &     ! inputs
-                  f_ph, f_pco2w, f_h2co3, f_hco3, f_co3, f_omcal(ji,jj),             &     ! outputs
-                  f_omarg(ji,jj), f_co2flux, f_TDIC, f_TALK, f_dcf, f_henry, iters )       ! outputs
+                  CALL trc_co2_medusa( ztmp, zsal, zdic, zalk, 0.0, f_kw660, f_pco2a,  &  ! inputs
+                  f_ph, f_pco2w, f_h2co3, f_hco3, f_co3, f_omcal(ji,jj),               &  ! outputs
+                  f_omarg(ji,jj), f_co2flux, f_TDIC, f_TALK, f_dcf, f_henry, iters )      ! outputs
                   !!
                   !! AXY (09/01/14): removed iteration and NaN checks; these have
@@ -869,4 +1437,5 @@
                      iters, ' AT (', ji, ', ', jj, ', ', jk, ') AT ', kt
                   endif
+#   endif
 #  else
                   !! AXY (18/04/13): switch off carbonate chemistry calculations; provide
@@ -882,18 +1451,34 @@
                   f_TDIC         = zdic
                   f_TALK         = zalk
-                  f_dcf          = 1.
+                  f_dcf          = 1.026
                   f_henry        = 1.
+                  !! AXY (23/06/15): add in some extra MOCSY diagnostics
+                  f_fco2w        = fpco2a
+                  f_BetaD        = 1.
+                  f_rhosw        = 1.026
+                  f_opres        = 0.
+                  f_insitut      = ztmp
+                  f_pco2atm      = fpco2a
+                  f_fco2atm      = fpco2a
+                  f_schmidtco2   = 660.
+                  f_kwco2        = 0.
+                  f_K0           = 0.
+                  f_co2starair   = fpco2a
+                  f_dpco2        = 0.
 #  endif
                   !!
-                  !! already in right units; correct for sea-ice; divide through by layer thickness
-                  f_co2flux = (1. - fr_i(ji,jj)) * f_co2flux / fthk
+                  !! mmol/m2/s -> mmol/m3/d; correct for sea-ice; divide through by layer thickness
+                  f_co2flux = (1. - fr_i(ji,jj)) * f_co2flux * 86400. / fthk
                   !!
                   !! oxygen (O2); OCMIP-2 code
-                  CALL trc_oxy_medusa( ztmp, zsal, f_uwind, f_vwind, f_pp0, zoxy / 1000., fthk, &  ! inputs
-                  f_kw660, f_o2flux, f_o2sat )                                                     ! outputs
-                  !!
-                  !! mol/m3/s -> mmol/m3/d; correct for sea-ice
-                  f_o2flux  = (1. - fr_i(ji,jj)) * f_o2flux * 1000. * 60. * 60. * 24. 
-                  f_o2sat   = f_o2sat  * 1000.
+                  !! AXY (23/06/15): amend input list for oxygen to account for common gas
+                  !!                 transfer velocity
+                  !! CALL trc_oxy_medusa( ztmp, zsal, f_uwind, f_vwind, f_pp0, zoxy / 1000., fthk,  &  ! inputs
+                  !! f_kw660, f_o2flux, f_o2sat )                                                      ! outputs
+                  CALL trc_oxy_medusa( ztmp, zsal, f_kw660, f_pp0, zoxy,  &  ! inputs
+                  f_kwo2, f_o2flux, f_o2sat )                                ! outputs
+                  !!
+                  !! mmol/m2/s -> mol/m3/d; correct for sea-ice; divide through by layer thickness
+                  f_o2flux  = (1. - fr_i(ji,jj)) * f_o2flux * 86400. / fthk
                   !!
                   !! Jpalm (08-2014)
@@ -911,11 +1496,85 @@
                   !!
                   IF (jdms .eq. 1) THEN
-                  !!
-                     !! CALL trc_dms_medusa( zchn, zchd, hmld(ji,jj), &                            !! inputs
-                     !! dms_surf )                                                                 !! outputs
-                     CALL trc_dms_medusa( zchn, zchd, hmld(ji,jj), qsr(ji,jj), zdin, &             !! inputs
-                     dms_surf, dms_andr, dms_simo, dms_aran, dms_hall )                            !! outputs
+                     !!
+                     !! feed in correct inputs
+                     if (jdms_input .eq. 0) then
+                        !! use instantaneous inputs
+                        CALL trc_dms_medusa( zchn, zchd, hmld(ji,jj), qsr(ji,jj), zdin, &  ! inputs
+                        dms_andr, dms_simo, dms_aran, dms_hall )                           ! outputs
+                     else
+                        !! use diel-average inputs
+                        CALL trc_dms_medusa( zn_dms_chn(ji,jj), zn_dms_chd(ji,jj), &  ! inputs
+                        zn_dms_mld(ji,jj), zn_dms_qsr(ji,jj), zn_dms_din(ji,jj),   &  ! inputs
+                        dms_andr, dms_simo, dms_aran, dms_hall )                      ! outputs
+                     endif
+                     !!
+                     !! assign correct output to variable passed to atmosphere
+                     if     (jdms_model .eq. 1) then
+                        dms_surf = dms_andr
+                     elseif (jdms_model .eq. 2) then
+                        dms_surf = dms_simo
+                     elseif (jdms_model .eq. 3) then
+                        dms_surf = dms_aran
+                     elseif (jdms_model .eq. 4) then
+                        dms_surf = dms_hall
+                     endif
+                     !!
+                     !! 2D diag through iom_use
+                     IF( lk_iomput ) THEN
+                       IF( med_diag%DMS_SURF%dgsave ) THEN
+                         dms_surf2d(ji,jj) = dms_surf
+                       ENDIF
+                       IF( med_diag%DMS_ANDR%dgsave ) THEN
+                         dms_andr2d(ji,jj) = dms_andr
+                       ENDIF
+                       IF( med_diag%DMS_SIMO%dgsave ) THEN
+                         dms_simo2d(ji,jj) = dms_simo
+                       ENDIF
+                       IF( med_diag%DMS_ARAN%dgsave ) THEN
+                         dms_aran2d(ji,jj) = dms_aran
+                       ENDIF
+                       IF( med_diag%DMS_HALL%dgsave ) THEN
+                         dms_hall2d(ji,jj) = dms_hall
+                       ENDIF
+#   if defined key_debug_medusa
+                       IF (lwp) write (numout,*) 'trc_bio_medusa: finnish calculating dms'
+                     CALL flush(numout)
+#   endif 
+                     ENDIF
+                     !! End iom
                   ENDIF
                   !! End DMS Loop
+                  !!
+                  !! store 2D outputs
+                  IF ( lk_iomput ) THEN
+                      IF( med_diag%ATM_PCO2%dgsave ) THEN
+                         f_pco2a2d(ji,jj) = f_pco2a
+                      ENDIF
+                      IF( med_diag%OCN_PCO2%dgsave ) THEN
+                         f_pco2w2d(ji,jj) = f_pco2w
+                      ENDIF
+                      IF( med_diag%CO2FLUX%dgsave ) THEN
+                         f_co2flux2d(ji,jj) = f_co2flux
+                      ENDIF
+                      IF( med_diag%TCO2%dgsave ) THEN
+                         f_TDIC2d(ji,jj) = f_TDIC
+                      ENDIF
+                      IF( med_diag%TALK%dgsave ) THEN
+                         f_TALK2d(ji,jj) = f_TALK
+                      ENDIF
+                      IF( med_diag%KW660%dgsave ) THEN
+                         f_kw6602d(ji,jj) = f_kw660
+                      ENDIF
+                      IF( med_diag%ATM_PP0%dgsave ) THEN
+                         f_pp02d(ji,jj) = f_pp0
+                      ENDIF
+                      IF( med_diag%O2FLUX%dgsave ) THEN
+                         f_o2flux2d(ji,jj) = f_o2flux
+                      ENDIF
+                      IF( med_diag%O2SAT%dgsave ) THEN
+                         f_o2sat2d(ji,jj) = f_o2sat
+                      ENDIF
+                  ENDIF
+                  !! 
                endif
                !! End jk = 1 loop within ROAM key 
@@ -953,5 +1612,5 @@
                   !! alkalinity are derived from continent-scale DIC estimates (Huang et al., 
                   !! 2012) and some Arctic river alkalinity estimates (Katya?)
-                  !!      
+                  !! 
                   !! as of 19/07/12, riverine nutrients can now be spread vertically across 
                   !! several grid cells rather than just poured into the surface box; this
@@ -1216,7 +1875,17 @@
                endif
                !!
-               fprn_ml = (fprn * zphn * fthk * fq0)
-               fprd_ml = (fprd * zphd * fthk * fq0)
-
+               fprn_ml(ji,jj) = fprn_ml(ji,jj) + (fprn * zphn * fthk * fq0)
+               fprd_ml(ji,jj) = fprd_ml(ji,jj) + (fprd * zphd * fthk * fq0)
+               
+               !!----------------------------------------------------------------------
+               !! Vertical Integral --
+               !!----------------------------------------------------------------------
+               ftot_pn(ji,jj)  = ftot_pn(ji,jj)  + (zphn * fthk)   !! vertical integral non-diatom phytoplankton
+               ftot_pd(ji,jj)  = ftot_pd(ji,jj)  + (zphd * fthk)   !! vertical integral diatom phytoplankton
+               ftot_zmi(ji,jj) = ftot_zmi(ji,jj) + (zzmi * fthk)   !! vertical integral microzooplankton
+               ftot_zme(ji,jj) = ftot_zme(ji,jj) + (zzme * fthk)   !! vertical integral mesozooplankton
+               ftot_det(ji,jj) = ftot_det(ji,jj) + (zdet * fthk)   !! vertical integral slow detritus, nitrogen
+               ftot_dtc(ji,jj) = ftot_dtc(ji,jj) + (zdtc * fthk)   !! vertical integral slow detritus, carbon
+               
                !!----------------------------------------------------------------------
                !! More chlorophyll calculations
@@ -1535,5 +2204,5 @@
                !! "free" iron concentration (and convert to mmol Fe / m3)
                xFeF        = (xFeT - xFeL) * 1.e-3
-               xFree       = xFeF / (zfer + tiny(zfer))
+               xFree(ji,jj)= xFeF / (zfer + tiny(zfer))
                !!
                !! scavenging of iron (multiple schemes); I'm only really happy with the 
@@ -1842,5 +2511,5 @@
                   IF (lwp) write (numout,*) 'ffetop(',jk,')  = ', ffetop
                   IF (lwp) write (numout,*) 'ffebot(',jk,')  = ', ffebot
-                  IF (lwp) write (numout,*) 'xFree(',jk,')   = ', xFree
+                  IF (lwp) write (numout,*) 'xFree(',jk,')   = ', xFree(ji,jj)
                   IF (lwp) write (numout,*) 'ffescav(',jk,') = ', ffescav
                endif
@@ -1875,5 +2544,5 @@
                !! standard depths in the diagnostic outputs; needs to be
                !! adjusted from per second to per day because of parameter vsed
-               fslownflux = zdet * vsed * 86400.
+               fslownflux(ji,jj) = zdet * vsed * 86400.
 # if defined key_roam
                !!
@@ -1888,5 +2557,5 @@
                !! standard depths in the diagnostic outputs; needs to be
                !! adjusted from per second to per day because of parameter vsed
-               fslowcflux = zdtc * vsed * 86400.
+               fslowcflux(ji,jj) = zdtc * vsed * 86400.
 # endif
 
@@ -2401,5 +3070,5 @@
                      f_fbenin_c(ji,jj)  = ffastc(ji,jj)             !! fast C -> benthic C                       (mol/m2)
                   endif
-                  fsedc    = ffastc(ji,jj)                          !! record seafloor C                         (mol/m2)
+                  fsedc(ji,jj)   = ffastc(ji,jj)                          !! record seafloor C                         (mol/m2)
                   ffastc(ji,jj)  = 0.0
                   !!
@@ -2413,5 +3082,5 @@
                      f_fbenin_n(ji,jj)  = ffastn(ji,jj)             !! fast N -> benthic N                       (mol/m2)
                   endif
-                  fsedn    = ffastn(ji,jj)                          !! record seafloor N                         (mol/m2)
+                  fsedn(ji,jj)   = ffastn(ji,jj)                          !! record seafloor N                         (mol/m2)
                   ffastn(ji,jj)  = 0.0
                   !!
@@ -2424,5 +3093,5 @@
                      f_fbenin_fe(ji,jj) = ffastfe(ji,jj)            !! fast Fe -> benthic Fe                     (mol/m2)
                   endif
-                  fsedfe   = ffastfe(ji,jj)                         !! record seafloor Fe                        (mol/m2)
+                  fsedfe(ji,jj)  = ffastfe(ji,jj)                         !! record seafloor Fe                        (mol/m2)
                   ffastfe(ji,jj) = 0.0
                   !!
@@ -2433,5 +3102,5 @@
                      f_fbenin_si(ji,jj) = ffastsi(ji,jj)            !! fast Si -> benthic Si                     (mol/m2)
                   endif
-                  fsedsi   = ffastsi(ji,jj)                         !! record seafloor Si                        (mol/m2)
+                  fsedsi(ji,jj)   = ffastsi(ji,jj)                         !! record seafloor Si                        (mol/m2)
                   ffastsi(ji,jj) = 0.0
                   !!
@@ -2442,5 +3111,5 @@
                      f_fbenin_ca(ji,jj) = ffastca(ji,jj)            !! fast Ca -> benthic Ca                     (mol/m2)
                   endif
-                  fsedca   = ffastca(ji,jj)                         !! record seafloor Ca                        (mol/m2)
+                  fsedca(ji,jj)   = ffastca(ji,jj)                         !! record seafloor Ca                        (mol/m2)
                   ffastca(ji,jj) = 0.0
                endif
@@ -2639,5 +3308,5 @@
                !!
                !! community respiration (does not include CaCO3 terms - obviously!)
-               fcomm_resp = fc_prod
+               fcomm_resp(ji,jj) = fcomm_resp(ji,jj) + fc_prod
                !!
                !! CaCO3
@@ -2841,4 +3510,11 @@
                endif               
 
+#   if defined key_debug_medusa
+               IF (lwp) write (numout,*) '------'
+               IF (lwp) write (numout,*) 'trc_bio_medusa: end all calculations'
+               IF (lwp) write (numout,*) 'trc_bio_medusa: now outputs'
+                     CALL flush(numout)
+#   endif
+
 # if defined key_axy_nancheck
                !!----------------------------------------------------------------------
